Ball [] balls = new Ball[3]; //declare a array of custom objects of type Ball
Paddle paddle; //declare a custom object of type Paddle

int points = 0;
boolean gameOver = false;

void setup()
{
  size(800, 600);
  
  //when using objects we must use "new" to allocate space and call their constructors
  for(int i = 0; i < balls.length; i++)
  {
    balls[i] = new Ball(); 
  }
  paddle = new Paddle(20, 100);
  
  //frameRate(2);
  
  textSize(64);
}

void draw()
{
  background(0);
  
  /////////////////////////////////////////////////////////////////////////////////
  //Text Display
  if(gameOver)
    text("GAME OVER!!!!!", 0, 50);
  else
    text(points, 0, 50);
  
  /////////////////////////////////////////////////////////////////////////////////
  //Update and Draw Paddle
  paddle.update(); //update movement - this is a custom function, can be called anything
  paddle.display(); //drawing code for paddle - can be called anything except "draw"
  
  /////////////////////////////////////////////////////////////////////////////////
  //Update and Draw all the balls
  for(int i = 0; i < balls.length; i++)
  {
    balls[i].update(); //update movement
    balls[i].display(); //draw ball
  
    //Check if the ball is hit by the paddle
    float ballLeft = balls[i].x - balls[i].size/2;
    boolean isHit = paddle.hit(ballLeft, balls[i].y);
    if(isHit)
    {
     //println("HIT!!!!!");
     balls[i].xDir *= -1;
     //ball.size += 20; //increase the size with each hit
     //ball.x = paddle.x + paddle.w + ball.size/2; //fix the bounds with each hit
     //ball.speed += 5; //increase the speed with each hit
     
     //add points
     points++;
    } 
  } //end of the balls loop
  
  /////////////////////////////////////////////////////////////////////////////////
  //Figure out if the game is over
  boolean isOver = true;
  for(int i = 0; i < balls.length; i++)
  {
    if(balls[i].x > 0)
    {
      isOver = false; 
    }
  }
  gameOver = isOver;
  if(gameOver)
  {
   points = 0; 
  }
  
}

void mouseClicked()
{
  if(gameOver)
  {
    for(int i = 0; i < balls.length; i++)
    {
      balls[i].reset();
    }
    gameOver = false;
  }
}